#! /usr/bin/env python
# -*- coding: latin-1 -*-
# 
# Programa: conexionesEOD.py
# Proposito: Presenta resumen de conexiones EOD
# Autor: Antonio Delgado Rodríguez
# Fecha: 12-Enero-2014
#
# Datos Entrada: conexionesEOD.txt
#

import re
import datetime 
import time


class Usuario():
    # inicializamos campos  
    def __init__(self):
      self.conexion=''
      self.alias=''
      self.display=0
      self.ip=''  
      self.servidor=''
      self.desconexion=''
      self.tiempo=0
      # self = ['','',0,'','','',0]

    #Averigua si hay un estudiante en la lista de lista_usuarios con
    #lista.nombre = nombre
    def existe_usuario(lista, nombre):
      for usuario in lista:
        if nombre == usuario.nombre:
          return True
      return False

    # Mostramos usuario 
    def mostrar_usuario(self):
      print("Conexion:%-16s alias:%-8s display:%-3s ip:%-15s Servidor:%-4s Desconexion:%-16s Tiempo:%-6s" 
            % (self.conexion,self.alias,self.display,self.ip,self.servidor,self.desconexion,self.tiempo)) 
 
    # Crea un usuario 
    def crea_usuario(self,conexion,alias,display,ip,servidor,desconexion):
      self.conexion=conexion
      self.alias=alias
      self.display=display
      self.ip=ip
      self.servidor=servidor
      self.desconexion=desconexion

      ts1 = time.mktime(time.strptime(self.conexion,'%Y/%m/%d %H:%M:%S'))
      ts2 = time.mktime(time.strptime(self.desconexion,'%Y/%m/%d %H:%M:%S'))
      ts = int(ts2 - ts1)
      self.tiempo=ts

    #Añade usuario a lista de usuarios
    def anade_usuario(self, lista):
      lista.append(self)
      #lista[lista.index(self)].mostrar_usuario()
      #for i in range(0,len(lista)-1):
      #  lista[i].mostrar_usuario()
      
    #Lista la lista de usuarios
    def listado_completo(self, lista): 
      #for i in range(0,len(lista)):
      #  lista[i].mostrar_usuario()
      for self in lista:
        self.mostrar_usuario()

def lee_datos():
  #Abrimos fichero en modo solo lectura
  file=open('conexionesEOD.txt','r')

  #Leemos linea a linea el fichero.Nos colocamos al principio
  file.seek(0,0)
  for linea in file:
    alias = ''
    #Buscamos inicio de conexion          
    if (re.search("Successful login",linea)):
      campos=linea.split()
      conexion=campos[0] + " " + campos[1]
      alias=campos[2]
      display=campos[3]
      aux=campos[7].split(':')
      ip=aux[0]
      posicion=file.tell()

      #Bucle hasta encontra segunda parte del inicio de conexion
      #y desconexion
      for linea in file:  
        # Segunda parte de la conexion
        if (re.search("launched", linea)):
          campos=linea.split()
          if (campos[2] is alias):
            continue
          servidor=campos[10]

        # Desconexion
        if (re.search("Error reading from client", linea)):
          campos=linea.split()
          if (campos[2] is alias):
            continue
          desconexion=campos[0] + " " + campos[1]
          break
     
    if (alias != ''):
      #Creamos registro
      usuario.crea_usuario(conexion,alias,display,ip,servidor,desconexion)

      #Mostramos registro creado
      #usuario.mostrar_usuario()
      
      #Añadimos registro a lista usuarios 
      usuario.anade_usuario(lista_usuarios)

      #Colocamos posicion lectura
      #file.seek(posicion)

  #Cerramos el fichero
  file.close()

#
# MAIN
#

#Lista de registros de conexiones
lista_usuarios = [] 

# instanciamos clase Usuario
usuario = Usuario()

#Leemos de fichero
lee_datos()

#Imprimimos numero regisros
print 'Registros leidos: %d' % len(lista_usuarios)

#Listamos usuarios
#for i in range(0,len(lista_usuarios)):
  #lista_usuarios[i].mostrar_usuario()

usuario.listado_completo(lista_usuarios)
